﻿using MVCSampleBrowser.Models;
using Syncfusion.JavaScript.DataSources;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using Syncfusion.Linq;
using System.Web;
using System.Web.Mvc;
using Syncfusion.JavaScript.Models;
using System.Web.Script.Serialization;
using System.Reflection;
using Newtonsoft.Json;
using System.Data;
using System.Data.SqlClient;
using System.Dynamic;
using System.Threading;
using System.Reflection.Emit;
using System.ComponentModel.DataAnnotations;

namespace MvcApplication66.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            ViewBag.data = OrderRepository.GetAllRecords().ToList();
            ViewBag.empData = new NorthwindDataContext().EmployeeViews.ToList();
            ViewBag.OrdData = new NorthwindDataContext().OrdersViews.ToList();
            return View();
        }
        public ActionResult DataSource(Syncfusion.JavaScript.DataManager dm)
        {
            DataSet ds = new DataSet();
            DataTable dt;
            DataRow dr;
            DataColumn idCoulumn;
            DataColumn nameCoulumn;
            DataColumn nameCoulumn1;
            DataColumn nameCoulumn2;
            DataColumn nameCoulumn3;
            DataColumn nameCoulumn4;
            DataColumn nameCoulumn5;
            DataColumn nameCoulumn6;
            DataColumn dateCoulumn;
            int i = 0;

            dt = new DataTable();
            idCoulumn = new DataColumn("Id", Type.GetType("System.Guid"));
            nameCoulumn = new DataColumn("cod_div", Type.GetType("System.String"));
            nameCoulumn1 = new DataColumn("cod_soc", Type.GetType("System.String"));
            nameCoulumn2 = new DataColumn("cod_fil", Type.GetType("System.String"));
            dateCoulumn = new DataColumn("data_fest", Type.GetType("System.DateTime"));
            nameCoulumn3 = new DataColumn("cod_lng", Type.GetType("System.String"));
            nameCoulumn4 = new DataColumn("ind_ogni_anno", Type.GetType("System.String"));
            nameCoulumn5 = new DataColumn("descrizione", Type.GetType("System.String"));
            nameCoulumn6 = new DataColumn("flag_tratt", Type.GetType("System.String"));

            dt.Columns.Add(nameCoulumn);
            dt.Columns.Add(nameCoulumn1);
            dt.Columns.Add(nameCoulumn2);
            dt.Columns.Add(dateCoulumn);
            dt.Columns.Add(nameCoulumn3);
            dt.Columns.Add(nameCoulumn4);
            dt.Columns.Add(nameCoulumn5);
            dt.Columns.Add(nameCoulumn6);
            dt.Columns.Add(idCoulumn);

            dr = dt.NewRow();
            dr["cod_div"] = "Name1";
            dr["cod_soc"] = "Name1";
            dr["cod_fil"] = "Name1";
            dr["data_fest"] = new DateTime(1998, 04, 30);
            dr["cod_lng"] = "Name1";
            dr["ind_ogni_anno"] = "Name1";
            dr["descrizione"] = "Name1";
            dr["flag_tratt"] = "Name1";
            dr["Id"] = Guid.NewGuid();
            dt.Rows.Add(dr);

            dr = dt.NewRow();
            dr["cod_div"] = "Name2";
            dr["cod_soc"] = "Name3";
            dr["cod_fil"] = "Name4";
            dr["data_fest"] = new DateTime(1998, 04, 30);
            dr["cod_lng"] = "Name5";
            dr["ind_ogni_anno"] = "Name7";
            dr["descrizione"] = "Name2";
            dr["flag_tratt"] = "Name2";
            dr["Id"] = Guid.NewGuid();
            dt.Rows.Add(dr);

            ds.Tables.Add(dt);
            DataSet myDataSet = ds;
            IEnumerable DataSource = convertToTypedList(myDataSet);
            //IEnumerable DataSource = new NorthwindDataContext().OrdersViews.ToList();
            DataOperations dp = new DataOperations();
            DataResult result = new DataResult();
            result.count = DataSource.AsQueryable().Count();
            if (dm.Where != null)
            {
                DataSource = dp.PerformWhereFilter(DataSource, dm.Where, dm.Where[0].Operator);
                result.count = DataSource.AsQueryable().Count();//updates the origninal record count after filtering
                if (dm.Take == 0)
                    return Json(DataSource, JsonRequestBehavior.AllowGet);//Return records alone for the autoComplete list
            }
            DataSource = dp.Execute(DataSource, dm);
            result.result = DataSource;
            return Json(result, JsonRequestBehavior.AllowGet);
        }
        public class Festivita
        {
            [Key]
            public Guid Id { get; set; }

            //PK chiavi primarie 
            public string cod_div { get; set; }
            public string cod_soc { get; set; }
            public string cod_fil { get; set; }
            public DateTime data_fest { get; set; }
            public string cod_lng { get; set; }
            public string ind_ogni_anno { get; set; }
            public string descrizione { get; set; }
            public string flag_tratt;
        }

        public List<Festivita> convertToTypedList(DataSet ds)
        {
            List<Festivita> lista = (from c in ds.Tables[0].AsEnumerable()
                                     select new Festivita()
                                     {
                                         cod_div = c[0].ToString(),
                                         cod_soc = c[1].ToString(),
                                         cod_fil = c[2].ToString(),
                                         data_fest = DateTime.Parse(c[3].ToString()),
                                         ind_ogni_anno = c[4].ToString(),
                                         cod_lng = c[5].ToString(),
                                         descrizione = c[6].ToString(),
                                         flag_tratt = c[7].ToString(),
                                         Id = Guid.Parse(c[8].ToString()),
                                     }).ToList();
            return lista;
        }
        public ActionResult CrudUpdate(EditableOrder value, string action, int key)
        {
            if (action == "update")
            {
                OrderRepository.Update(value);
                var data = OrderRepository.GetAllRecords();
            }
            else if (action == "insert")
            {
                OrderRepository.Add(value);
                var data = OrderRepository.GetAllRecords();
            }
            else if (action == "remove")
            {
                var key1 = Request.Headers.GetValues("OrderID")[0];
                var key2 = Request.Headers.GetValues("EmployeeID")[0];
                OrderRepository.Delete(key);
                var data = OrderRepository.GetAllRecords();
            }
            return View();
        }
        public class DataResult
        {
            public IEnumerable result { get; set; }
            public int count { get; set; }
        }
        public ActionResult Update(EditableOrder value)
        {
            OrderRepository.Update(value);
            var data = OrderRepository.GetAllRecords();
            return Json(data, JsonRequestBehavior.AllowGet);
        }
        public ActionResult Insert(EditableOrder value)
        {
            OrderRepository.Add(value);
            var data = OrderRepository.GetAllRecords();
            return Json(data, JsonRequestBehavior.AllowGet);
        }
        public ActionResult Delete(int key)
        {
            OrderRepository.Delete(key);
            var data = OrderRepository.GetAllRecords();
            return Json(data, JsonRequestBehavior.AllowGet);
        }
    }
}